   MEMBER()

   include('svapi.inc')
   include('ftp.def')
   include('WinInet.inc','Equates')
   include('WinInet.inc','Types')
   MAP
     Include('winapi.inc','Prototypes')
     Include('WinInet.inc','Prototypes')
   END

FTP.Init Procedure(STRING Svr,<STRING Agnt>,<ULONG AType>,<STRING Prxy>,<STRING PrxyByPass>)
   Code

   SELF.ErrorClass       &= NEW(WinError)
   SELF.ErrorClass.Init
   SELF.ErrorClass.AddLibrary('wininet.dll')

   SELF.CurrentDirectory &= NEW(STRING(MAX_PATH))
   SELF.CurrentDirectoryLength = MAX_PATH

   SELF.Server           &= NEW(CSTRING(Len(CLIP(Svr))+1))
   SELF.Server            = Svr

   If ~OMITTED(3)
      SELF.Agent &= NEW(CSTRING(Len(Agnt)+1))
      SELF.Agent = Agnt
   Else
      SELF.Agent &= NEW(CSTRING(16))
      SELF.Agent = 'FTP client'
   End
   If ~OMITTED(4)
      SELF.AccessType = AType
      If ~OMITTED(5) AND AType <> INTERNET_OPEN_TYPE_PRECONFIG
         SELF.Proxy &= NEW(CSTRING(Len(Prxy)+1))
         SELF.Proxy = Prxy
      End
   Else
      SELF.AccessType = INTERNET_OPEN_TYPE_PRECONFIG
   End

   If ~OMITTED(6)
      SELF.ProxyByPass &= NEW(CSTRING(Len(PrxyByPass)+1))
      SELF.ProxyByPass = PrxyByPass
   End

   SELF.SessionHandle = 0
   SELF.FtpHandle     = 0

FTP.IsSession       PROCEDURE
   Code
   Return SELF.SessionHandle

FTP.IsConnected       PROCEDURE
   Code
   Return SELF.FtpHandle

FTP.SetServerUser Procedure(STRING Usr,STRING Pwd)
   CODE
   RETURN (SELF.SetUser( Usr, Pwd, UserType:Server))

FTP.SetProxyUser Procedure(STRING Usr,STRING Pwd)
   CODE
   RETURN (SELF.SetUser( Usr, Pwd, UserType:Proxy))

FTP.SetUser Procedure(STRING Usr,STRING Pwd,BYTE Type)
RetVal   ULONG
   Code
   Case Type
   Of UserType:Server
      If SELF.InetUser &= NULL
         SELF.InetUser &= NEW(CSTRING(Len(CLIP(Usr))+1))
      end
      SELF.InetUser = Usr
      If SELF.InetPassword &= NULL
         SELF.InetPassword &= NEW(CSTRING(Len(CLIP(Pwd))+1))
      end
      SELF.InetPassword = Pwd
   Of UserType:Proxy
      If SELF.ProxyUser &= NULL
         SELF.ProxyUser &= NEW(CSTRING(Len(Usr)+1))
      end
      SELF.ProxyUser = Usr
      If ~InternetSetOption(SELF.FtpHandle,INTERNET_OPTION_PROXY_USERNAME,ADDRESS(SELF.ProxyUser),SIZE(SELF.ProxyUser))
         RetVal = SELF.GetError()
      ELSE
         If SELF.ProxyPassword &= NULL
            SELF.ProxyPassword &= NEW(CSTRING(Len(Pwd)+1))
         end
         SELF.ProxyPassword = Pwd
         If ~InternetSetOption(SELF.FtpHandle,INTERNET_OPTION_PROXY_PASSWORD,ADDRESS(SELF.ProxyPassword),SIZE(SELF.ProxyPassword))
            RetVal = SELF.GetError()
         END
      End
   End
   Return RetVal

FTP.GetFileSize     PROCEDURE(STRING FileName,*ULONG FileSizeHigh,<DWORD Access>,<DWORD Flags>,DWORD Context=0)
RetVal      DWORD
FileHandle  DWORD
FN          &CSTRING
   Code

   FN &= NEW(CSTRING(Len(FileName)+1))
   IF Omitted(4) then Access = GENERIC_READ .
   IF Omitted(5) then Flags = FTP_TRANSFER_TYPE_BINARY .

   FileHandle = FtpOpenFile(SELF.FtpHandle,ADDRESS(FN),Access,Flags,Context)
   If ~FileHandle
      RetVal = SELF.GetError()
   Else
     RetVal = FtpGetFileSize(FileHandle,ADDRESS(FileSizeHigh))
     IF ~RetVal then RetVal = SELF.GetError() .
   End
   Dispose(FN)
   RETURN RetVal

FTP.GetCurrentDirectory PROCEDURE
RetVal   DWORD
CD       CSTRING(MAX_PATH)
   Code
   SELF.CurrentDirectoryLength = MAX_PATH
   If ~FtpGetCurrentDirectory(SELF.FtpHandle,ADDRESS(CD),ADDRESS(SELF.CurrentDirectoryLength))
      RetVal = SELF.GetError()
   End
   SELF.CurrentDirectory = CD
   Return RetVal

FTP.GetCurrentPath PROCEDURE
   Code
   If ~SELF.CurrentDirectory
      IF SELF.GetCurrentDirectory() . .
   Return (SELF.CurrentDirectory)

FTP.GetCurrentPathLength PROCEDURE
   Code
   If ~SELF.CurrentDirectoryLength
      If SELF.GetCurrentDirectory() then . .
   Return (SELF.CurrentDirectoryLength)


FTP.ChangeDirectory     PROCEDURE(STRING NewDirectory)
RetVal   DWORD
ND       &CSTRING
   CODE
   ND &= NEW(CSTRING(Len(NewDirectory)+1))
   ND = NewDirectory
   if ~FtpSetCurrentDirectory(SELF.FtpHandle,ADDRESS(ND))
      RetVal = SELF.GetError()
   Else
      RetVal = SELF.GetCurrentDirectory()
   End
   Dispose(ND)
   Return RetVal

FTP.CreateDirectory  PROCEDURE(STRING NewDirectory)
RetVal   DWORD
ND       &CSTRING
  Code
  ND &= NEW(CSTRING(Len(NewDirectory)+1))
  ND = NewDirectory
  If ~FtpCreateDirectory(SELF.FtpHandle,ADDRESS(ND)) Then RetVal = SELF.GetError() .
  Dispose(ND)
  Return RetVal


FTP.Download        PROCEDURE(STRING RemoteFileName,STRING LocalFileName,BOOL FailIfExists=FALSE,<DWORD LocalFlagsAndAttributes>,<DWORD InternetFlags>,DWORD Context = 0)
RetVal   DWORD
RFN      &CSTRING
LFN      &CSTRING
   Code
   RFN &= NEW(CSTRING(Len(RemoteFileName)+1))
   RFN = RemoteFileName
   LFN &= NEW(CSTRING(Len(LocalFileName)+1))
   LFN = LocalFileName
   IF Omitted(5) Then LocalFlagsAndAttributes = FILE_ATTRIBUTE_NORMAL .
   IF Omitted(6) Then InternetFlags = FTP_TRANSFER_TYPE_BINARY .
   IF ~FtpGetFile(SELF.FtpHandle,ADDRESS(RFN),ADDRESS(LFN),FailIfExists,LocalFlagsAndAttributes,InternetFlags,Context)
      RetVal = SELF.GetError()
   END
   Dispose(RFN);Dispose(LFN)
   Return RetVal


FTP.RemoveDirectory  PROCEDURE(STRING DirectoryName)
RetVal   DWORD
DN       &CSTRING
  Code
  DN &= NEW(CSTRING(Len(DirectoryName)+1))
  DN = DirectoryName
  If ~FtpRemoveDirectory(SELF.FtpHandle,ADDRESS(DN)) Then RetVal = SELF.GetError() .
  Dispose(DN)
  Return RetVal

FTP.RenameFile       PROCEDURE(STRING OldFileName, STRING NewFileName)
RetVal   DWORD
OFN      &CSTRING
NFN      &CSTRING
   Code
   OFN &= NEW(CSTRING(Len(OldFileName)+1))
   OFN = OldFileName
   NFN &= NEW(CSTRING(Len(NewFileName)+1))
   NFN = NewFileName
   If ~FtpRenameFile(SELF.FtpHandle,ADDRESS(OFN),ADDRESS(NFN)) Then RetVal = SELF.GetError() .
   Dispose(OFN); Dispose(NFN)
   Return RetVal

FTP.RemoveFile       PROCEDURE(STRING FileName)
RetVal   DWORD
FN       &CSTRING
   Code
   FN &= NEW(CSTRING(Len(FileName)+1))
   FN = FileName
   IF ~FtpDeleteFile(SELF.FtpHandle,ADDRESS(FN)) Then RetVal = SELF.GetError() .
   Dispose(FN)
   Return Retval

FTP.Upload          PROCEDURE(STRING LocalFile,STRING NewRemoteFile,<ULONG Flags>,ULONG Context = 0)
RetVal   DWORD
LF       &CSTRING
RF       &CSTRING
   Code
   LF &= NEW(CSTRING(Len(LocalFile)+1))
   LF = LocalFile
   RF &= NEW(CSTRING(Len(NewRemoteFile)+1))
   RF = NewRemoteFile
   If Omitted(4) Then Flags = BOR(INTERNET_FLAG_RELOAD,INTERNET_FLAG_TRANSFER_BINARY) .
   If ~FtpPutFile(SELF.FtpHandle,ADDRESS(LF),ADDRESS(RF),Flags,Context) Then RetVal = SELF.GetError() .
   Dispose(LF); Dispose(RF)
   Return RetVal

FTP.Destruct PROCEDURE
   CODE
   SELF.Disconnect(True)

FTP.Connect  PROCEDURE(BYTE Passive = FALSE)
RetVal   ULONG
   CODE
   IF ~SELF.SessionHandle
      SELF.SessionHandle = InternetOpen(ADDRESS(SELF.Agent),SELF.AccessType,ADDRESS(SELF.Proxy),ADDRESS(SELF.ProxyByPass),INTERNET_FLAG_KEEP_CONNECTION)
   END
   IF SELF.SessionHandle
      IF Passive = TRUE
        SELF.FtpHandle = InternetConnect(SELF.SessionHandle,ADDRESS(SELF.Server),INTERNET_INVALID_PORT_NUMBER, |
                                       ADDRESS(SELF.InetUser),ADDRESS(SELF.InetPassword),INTERNET_SERVICE_FTP,INTERNET_FLAG_PASSIVE,0)
      ELSE
            SELF.FtpHandle = InternetConnect(SELF.SessionHandle,ADDRESS(SELF.Server),INTERNET_INVALID_PORT_NUMBER, |
                                       ADDRESS(SELF.InetUser),ADDRESS(SELF.InetPassword),INTERNET_SERVICE_FTP,0,0)
        END
      IF ~SELF.FtpHandle then RetVal = SELF.GetError().
   ELSE
      RetVal = SELF.GetError()
   END
   RETURN RetVal

FTP.Disconnect  PROCEDURE(BYTE Full=FALSE)
RetVal   BYTE
   CODE
   IF SELF.FtpHandle and ~InternetCloseHandle(SELF.FtpHandle) then RetVal = SELF.GetError() .
   IF Full then SELF.Kill .
   RETURN RetVal

FTP.GetError       PROCEDURE
RetVal         DWORD
MessageBuffer  CSTRING(1024)
BufferSize     DWORD(SIZE(MessageBuffer))
   Code
   RetVal = SELF.ErrorClass.GetError()
   IF RetVal = ERROR_INTERNET_EXTENDED_ERROR
      IF InternetGetLastResponseInfo(ADDRESS(RetVal),ADDRESS(MessageBuffer),ADDRESS(BufferSize))
         Message(CLIP(MessageBuffer),'Warning !',ICON:Hand)
      END
   END
   Return RetVal

FTP.ShowErrors     PROCEDURE(Byte Enabled)
   Code
   SELF.ErrorClass.EnableMessage = Enabled

FTP.Kill     PROCEDURE
   CODE
   IF ~SELF.ErrorClass  &= NULL
      SELF.ErrorClass.Kill
      Dispose(SELF.ErrorClass)
   END
   If ~SELF.Server        &= NULL then Dispose(SELF.Server).
   If ~SELF.Agent         &= NULL then Dispose(SELF.Agent).
   If ~SELF.Proxy         &= NULL then Dispose(SELF.Proxy).
   If ~SELF.ProxyByPass   &= NULL then Dispose(SELF.ProxyByPass).
   If ~SELF.ProxyUser     &= NULL then Dispose(SELF.ProxyUser).
   If ~SELF.ProxyPassword &= NULL then Dispose(SELF.ProxyPassword).
   If ~SELF.InetUser      &= NULL then Dispose(SELF.InetUser).
   If ~SELF.InetPassword  &= NULL then Dispose(SELF.InetPassword).
   If ~SELF.CurrentDirectory &= NULL then Dispose(SELF.CurrentDirectory).
   SELF.FtpHandle     = 0
   SELF.SessionHandle = 0
   SELF.CurrentDirectoryLength = 0
   SELF.AccessType    = 0

FTP.GetDirectoryList PROCEDURE(DirectoryListQueueType DL,<STRING M>)
RetVal      DWORD
Mask        CSTRING(129)
DirInfo     GROUP(WIN32_FIND_DATA).
DirHandle   HINTERNET
   Code
   If SELF.FtpHandle
      If Omitted(3)
         Mask = '*.*'
      Else
         Mask = CLIP(M)
      End
      FREE(DL)
      CLEAR(DL)
      DL.Name  = '..';
      DL.Attributes = FILE_ATTRIBUTE_DIRECTORY
      DL.Dir = True
      Add(DL)
?     ASSERT(~ERRORCODE())
      DirHandle = FtpFindFirstFile(SELF.FtpHandle,ADDRESS(Mask),ADDRESS(DirInfo),INTERNET_FLAG_RESYNCHRONIZE,0)
      if ~DirHandle
         IF SELF.ErrorClass.ErrCode() = ERROR_NO_MORE_FILES
            RetVal = ERROR_NO_MORE_FILES
         else
            RetVal = SELF.GetError()
         end
         InternetCloseHandle(DirHandle);
      else
         Do AddDirectoryList
         Loop
            if ~InternetFindNextFile(DirHandle,ADDRESS(DirInfo))
               If SELF.ErrorClass.ErrCode() = ERROR_NO_MORE_FILES
                  InternetCloseHandle(DirHandle);
                  RetVal = ERROR_NO_MORE_FILES
                  Break
               else
                  RetVal = SELF.GetError()
               end
            else
               Do AddDirectoryList
            end
         end
         InternetCloseHandle(DirHandle);
      end
   else
      RetVal = SELF.GetError()
   end
   SORT(DL,-DL.Dir,+DL.Name)
   Return RetVal

AddDirectoryList    ROUTINE
   CLEAR(DL)
   DL.Name         = DirInfo.FileName
   DL.Attributes   = DirInfo.FileAttributes
   IF BAND( DL.Attributes, FILE_ATTRIBUTE_DIRECTORY)
      DL.Dir = TRUE
   END
   DL.fFileDate[1] = SELF.GetDateTime(DirInfo.LastWriteTime,Info:Date)
   DL.fFileDate[2] = SELF.GetDateTime(DirInfo.CreationTime,Info:Date)
   DL.fFileDate[3] = SELF.GetDateTime(DirInfo.LastAccessTime,Info:Date)
   DL.fFileTime[1] = SELF.GetDateTime(DirInfo.LastWriteTime,Info:Time)
   DL.fFileTime[2] = SELF.GetDateTime(DirInfo.CreationTime,Info:Time)
   DL.fFileTime[3] = SELF.GetDateTime(DirInfo.LastAccessTime,Info:Time)
   IF ~BAND( DL.Attributes, FILE_ATTRIBUTE_DIRECTORY)
      DL.FileSize  = DirInfo.FileSizeHigh * MAXDWORD + DirInfo.FileSizeLow
   END
   Add(DL)
?  ASSERT( ~ERRORCODE() )


FTP.GetDateTime   PROCEDURE(FILETIME FT,BYTE Type)
RetVal      STRING(16)
LocalTime   GROUP(FILETIME).
SysTime     GROUP(SYSTEMTIME).
   Code
   FileTimeToLocalFileTime( ADDRESS(FT), ADDRESS(LocalTime))
   FileTimeToSystemTime( ADDRESS(LocalTime), ADDRESS(SysTime))
   CASE Type
   OF Info:Date
      RetVal = DEFORMAT(SysTime.Month & '/' & SysTime.Day & '/' & SysTime.Year, @d6 )
   OF Info:Time
      RetVal = DEFORMAT(SysTime.Hour & ':' & SysTime.Minute & ':' & SysTime.Second, @t4 )
   END
   Return RetVal